aboutsummaryrefslogtreecommitdiff
path: root/bin
diff options
context:
space:
mode:
authorMiquel Sabaté Solà <msabate@suse.com>2020-03-25 16:47:42 +0100
committerMiquel Sabaté Solà <msabate@suse.com>2020-03-25 16:47:42 +0100
commit24d81aed398339f516aca54f0c0a0e87a89cae94 (patch)
tree774f215c8aba2cc199064099e47b089628b59f6c /bin
parent040caa60d612911ef7cfa43e9050e7de4269173b (diff)
downloaddotfiles-24d81aed398339f516aca54f0c0a0e87a89cae94.tar.gz
dotfiles-24d81aed398339f516aca54f0c0a0e87a89cae94.zip
bin: added git nuke
This deletes a branch both locally and remotely. Signed-off-by: Miquel Sabaté Solà <msabate@suse.com>
Diffstat (limited to 'bin')
-rwxr-xr-xbin/git-nuke44
1 files changed, 44 insertions, 0 deletions
diff --git a/bin/git-nuke b/bin/git-nuke
new file mode 100755
index 0000000..183c2e7
--- /dev/null
+++ b/bin/git-nuke
@@ -0,0 +1,44 @@
+#!/bin/bash
+# Copyright (C) 2020 Miquel Sabaté Solà <mikisabate@gmail.com>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+# Nuke the given branch, both locally and remotely.
+
+# Give me one argument.
+if [ "$#" -ne 1 ]; then
+ echo "usage: git nuke <branch>"
+ exit 1
+fi
+
+# The `master` branch should not be removed.
+if [ "$1" = "master" ]; then
+ echo "You are not allowed to delete the 'master' branch."
+ exit 1
+fi
+
+full_name="$(git symbolic-ref HEAD 2>/dev/null)" || (echo "Detached branch, bailing..."; exit 1)
+name="$(basename "$full_name")"
+
+# If we are nuking the current branch, move to `master` first.
+if [ "$1" = "$name" ]; then
+ echo "Nuking the current branch, moving to 'master' first..."
+ git checkout --force master
+fi
+
+# Nuke it!
+git push origin :"$full_name"
+git branch --delete --force "$name"